Field calculator doesn't disable field addition, when layer doesn't have the capability
2012-07-30 04:32 AM - Giovanni Manghi

Status: Closed

Priority: Normal

Assignee:

Category: GUI

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 15459
Description

I'm not sure this will be seen as a bug from the dev point of view, but it is certainly and inconsistency from the users point of view.

It happens that if a PostGIS user has the proper permissions but it is not the table owner, can edit geometries and attributes (from within
the table of attributes), but cannot edit attributes with the field calculator.

I guess that the obvious reason is that the FC does "alter table" operations that are allowed only to table owners.

A suggestion that has been made is to create the new column (or update the existing column) into a new view instead of the original table.

Related issues:
Duplicated by QGIS Application - Bug report # 6143: Field Calculator - No upd... Closed 2012-08-02

Associated revisions

Revision 28b8ab09 - 2012-08-02 03:46 PM - Jiirgen Fischer

fix #6120

History

#1 - 2012-07-31 03:38 AM - Jiirgen Fischer

- Status changed from Open to Feedback

You mean the user can change attributes in the attribute table, but cannot update existing fields using the field calculator? That would be a bug.

If the user just can't add fields via the field calculator, the attribute table or the layer properties, because he lacks the required database permissions to do

that, that's not a bug.

#2 - 2012-07-31 05:25 AM - Giovanni Manghi

Jurgen Fischer wrote:

You mean the user can change attributes in the attribute table, but cannot update existing fields using the field calculator? That would be a bug.

If the user just can't add fields via the field calculator, the attribute table or the layer properties, because he lacks the required database permissions
to do that, that's not a bug.
Hi Jargen,
the answer to both questions is "yes". In particular:
- | gave the non owner user GRANT USAGE ON schema
- | gave the non owner user GRANT ALL geometry_columns
- | gave the non owner user GRANT SELECT ON spatial_ref_sys

- | gave the non owner user GRANT ALL ON table

The user as expected can't add/delete fields (from the table of attributes, vector properties or field calculator) but CAN edit/add/delete geometries and
attributes (from the table of attributes).

As not expected the user can't update an existing field using the field calculator, as the "ok" button remains always deactivated.

Moreover the "create new field" (in the field calculator) refers correctly "(not supported by provider)" but the checkbox remains active as also the "out field

name" and "output field type" puzzling even more the user.

#3 - 2012-08-02 03:36 AM - Jiirgen Fischer
- Subject changed from Field calculator cannot be used if a PostGIS user is not table owner to Field calculator doesn't disable field addition, when layer

doesn't have the capability

#4 - 2012-08-02 03:36 AM - Jiirgen Fischer
- Category changed from Data Provider/PostGIS to GUI

#5 - 2012-08-02 03:39 AM - Giovanni Manghi

Hi Jurgen,

I'm not sure the new title reflects correctly the issue that non owner users are not allowed to update fields wiht the FC.

#6 - 2012-08-02 04:55 AM - Juirgen Fischer

Giovanni Manghi wrote:

I'm not sure the new title reflects correctly the issue that non owner users are not allowed to update fields wiht the FC.

The field calculator doesn't know anything about specific providers. Providers have the optional capability to add attributes. And if | understood correctly

the field calculator fails to disable Ul options that required AddAttributes accordingly, if the provider (or in this case the layer) doesn't have that capability.

#7 - 2012-08-02 05:02 AM - Giovanni Manghi

Jurgen Fischer wrote:

Giovanni Manghi wrote:

I'm not sure the new title reflects correctly the issue that non owner users are not allowed to update fields wiht the FC.

The field calculator doesn't know anything about specific providers. Providers have the optional capability to add attributes. And if | understood
correctly the field calculator fails to disable Ul options that required AddAttributes accordingly, if the provider (or in this case the layer) doesn't have
that capability.

I'm not sure | am following you.

There are two separate issues, as far | have | understand (and you know | may be wrong, so excuse me if it is the case):

the important issue is that a non owner user, with the proper permissions, should still be able to update fields with the FC.

the less important issue (but still and issue) is that in same situation the GUI of FC (to allow choose options to create a new field) should be disabled.

This ticket was filed about the first issue, later | added a note also about the second one.

#8 - 2012-08-02 05:15 AM - Juirgen Fischer

Giovanni Manghi wrote:

the important issue is that a non owner user, with the proper permissions, should still be able to update fields with the FC.

That's outside of the scope of the field calculator. If the provider reports that the layer supports ChangeAttributeValues the field calculator should be able to

update the field values, if it doesn't the field calculator should not enable that option.

The option to add a new field should only be enabled, if the providers reports the AddAttributes capability.

So if the field calculator doesn't react on the capabililies accordingly it's a bug in the field calculator.

If the provider doesn't report the proper capabilities (see layer properties) it's a bug in the provider.

#9 - 2012-08-02 05:33 AM - Giovanni Manghi

That's outside of the scope of the field calculator. If the provider reports that the layer supports ChangeAttributeValues the field calculator should be

able to update the field values, if it doesn't the field calculator should not enable that option.

so it is a provider issue, right? As you changed the title of this ticket, should I file a new ticket?

The option to add a new field should only be enabled, if the providers reports the AddAttributes capability.

ok, this was already clear, in fact if you read above my comments | already told that this was working as expected. The non owner user can't add/remove

fields and it is ok.

So if the field calculator doesn't react on the capabililies accordingly it's a bug in the field calculator.

If the provider doesn't report the proper capabilities (see layer properties) it's a bug in the provider.

See above my comments: the NON owner user CAN add/delete/edit features in the canvas or in the table of attributes but CAN'T update a field in the FC
(the "OK" button is disabled). But as a mere user | can't say if it is a bug in the provider or in the FC.

#10 - 2012-08-02 06:37 AM - Giovanni Manghi
Jurgen Fischer wrote:

Giovanni Manghi wrote:

the important issue is that a non owner user, with the proper permissions, should still be able to update fields with the FC.

That's outside of the scope of the field calculator. If the provider reports that the layer supports ChangeAttributeValues the field calculator should be
able to update the field values, if it doesn't the field calculator should not enable that option.

The option to add a new field should only be enabled, if the providers reports the AddAttributes capability.

So if the field calculator doesn't react on the capabililies accordingly it's a bug in the field calculator.

If the provider doesn't report the proper capabilities (see layer properties) it's a bug in the provider.

Hi Jurgen please let me know if/what | have to do (file a new ticket or not, and eventually the right category), because I'm a little confused right now.

Thanks in advance.

#11 - 2012-08-02 06:50 AM - Jiirgen Fischer

Giovanni Manghi wrote:

But as a mere user | can't say if it is a bug in the provider or in the FC.

Why? The capabilities are listed in the layer properties meta data tab. With that and the comments above it should be possible - even for mere testing
team leads and long-term users ;) - to determine if the reported capabilities are wrong or the field calculators interpretation of it.

#12 - 2012-08-02 06:51 AM - Jiirgen Fischer
- Status changed from Feedback to Closed

Fixed in changeset commit:"28b8ab09add47914ebd2c678baf769160d65ee37".

#13 - 2012-08-02 07:20 AM - Giovanni Manghi

Why? The capabilities are listed in the layer properties meta data tab. With that and the comments above it should be possible - even for mere

testing team leads and long-term users ;) - to determine if the reported capabilities are wrong or the field calculators interpretation of it.

So, this is what metadata shows for a layer loaded with a non owner users, with permissions to edit the table

General:

Storage type of this layer: PostgreSQL database with PostGIS extension

Source for this layer: dbname='persist' host=mapserver.uevora.pt port=5432 user="persist' ssimode=disable key='id' srid=3763 type=POLYGON
table="lena_maio2012"."area_armadilhagem" (geom) sql=

Geometry type of the features in this layer: Polygon

The number of features in this layer: 1

Editing capabilities of this layer: Add Features, Delete Features, Change Attribute Values, Fast Access to Features at ID, Change Geometries
Extents:

In layer spatial reference system units : xMin,yMin -54926,-212755.94 : xMax,yMax -53926,-211755.95

Layer Spatial Reference System:

+proj=tmerc +lat_0=39.66825833333333 +lon_0=-8.133108333333334 +k=1 +x_0=0 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m
+no_defs

and as expected the user can edit geometries and attributes from the table of attributes, but cannot update a field with the FC (ad expected, or am |
wrong?). Your commit fixes this, right?

#14 - 2012-08-02 07:30 AM - Jiirgen Fischer

Giovanni Manghi wrote:

Editing capabilities of this layer: Add Features, Delete Features, Change Atiribute Values, Fast Access to Features at ID, Change Geometries

See: no "Add Attributes"”

and as expected the user can edit geometries and attributes from the table of attributes, but cannot update a field with the FC (ad expected, or am |

wrong?). Your commit fixes this, right?

Right, on layers without "Add Attributes" the field calculator was disabling both and not just adding of new fields.
